package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.OrderInfoService;
import com.gxwebsoft.shop.entity.OrderInfo;
import com.gxwebsoft.shop.param.OrderInfoParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 场地控制器
 *
 * @author 科技小王子
 * @since 2024-05-14 13:20:04
 */
@Api(tags = "场地管理")
@RestController
@RequestMapping("/api/shop/order-info")
public class OrderInfoController extends BaseController {
    @Resource
    private OrderInfoService orderInfoService;

    @ApiOperation("分页查询场地")
    @GetMapping("/page")
    public ApiResult<PageResult<OrderInfo>> page(OrderInfoParam param) {
        // 使用关联查询
        return success(orderInfoService.pageRel(param));
    }

    @ApiOperation("查询全部场地")
    @GetMapping()
    public ApiResult<List<OrderInfo>> list(OrderInfoParam param) {
        // 使用关联查询
        return success(orderInfoService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderInfo:list')")
    @ApiOperation("根据id查询场地")
    @GetMapping("/{id}")
    public ApiResult<OrderInfo> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(orderInfoService.getByIdRel(id));
    }

    @ApiOperation("添加场地")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OrderInfo orderInfo) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        //  orderInfo.setUserId(loginUser.getUserId());
        // }
        if (orderInfoService.save(orderInfo)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改场地")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OrderInfo orderInfo) {
        if (orderInfoService.updateById(orderInfo)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除场地")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (orderInfoService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加场地")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OrderInfo> list) {
        if (orderInfoService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改场地")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OrderInfo> batchParam) {
        if (batchParam.update(orderInfoService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除场地")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (orderInfoService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
